
#include "QCamView3.h"

#include "VideoApplication.h"
#include "VideoWindow.h"
#include "ControlWindow.h"

VideoApplication::VideoApplication():BApplication(SIGNATURE)
{
	BRect r(0,0,159,119);
	r.OffsetTo(BPoint(282,100));

	theMainMenu=new BPopUpMenu(APP_NAME,FALSE,FALSE);
	menuItems[0]=new BMenuItem("About " APP_NAME "...",new BMessage(B_ABOUT_REQUESTED),'A');
	menuItems[1]=new BMenuItem("Control Panel",new BMessage(mCONTROL),'C');
	menuItems[1]->SetTarget(be_app);
	menuItems[2]=new BMenuItem("Quit",new BMessage(B_QUIT_REQUESTED),'Q');

	theMainMenu->AddItem(menuItems[0]);
	theMainMenu->AddItem(menuItems[1]);
	theMainMenu->AddItem(menuItems[2]);

	SetMainMenu(theMainMenu);

	theVideoWindow=new VideoWindow(r);
	theControlWindow=new ControlWindow(theVideoWindow);

	theVideoWindow->Show();
}

void VideoApplication::AboutRequested(void)
{
	BAlert	*about;

	about=new BAlert(
		"",
		
		APP_NAME " " APP_VERSION "\n"
		"by Fredrik Roubert <roubert@df.lth.se>\n\n"
		"Based on the source code from Be, Inc. and the improvements made to that code by Steve Sprang.",
		
		"Who cares?"
	);
	
	about->Go();
}

bool VideoApplication::QuitRequested(void)
{
	theControlWindow->PostMessage(mREALLY_QUIT);
	return inherited::QuitRequested();
}

void VideoApplication::MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
		case mCONTROL:
			if(theControlWindow->IsHidden())
			{
				theControlWindow->Show();
				menuItems[1]->SetMarked(TRUE);
			}
			else
			{
				theControlWindow->Hide();
				menuItems[1]->SetMarked(FALSE);
			}
			break;
	}
}
